#
# The fuzz type-checker for Z
# File: absyn.x
# $Revision: 3.0 $
# Copyright (C) J.M. Spivey 1989, 1991
#

> para	::=	GIVEN [ident] | AXDEF schema | SDEF shead schema
>		| DEFEQ shead sexp | PRED pred
>		| DEFINE [ident] schema | EQEQ lhs expr
>		| DATA ident [arm]
>		| XTAME [word] | XABBREV [word]
: GIVEN		given
: AXDEF		axdef
: SDEF		heading schema_body
: DEFEQ		lhs rhs
: PRED		pred
: DEFINE	def_params def_body
: EQEQ		lhs rhs
: DATA		lhs rhs
: XTAME		args
: XABBREV	args

> shead ::=     SHEAD word [ident]
: SHEAD		tag params

> lhs	::=	LHS ident [ident] | INLHS ident [ident] | PRELHS ident [ident]
: LHS		tag params
: INLHS		tag params
: PRELHS	tag params

> arm	::=	ARM ident (optional expr)
: ARM		tag template

> schema ::=	BODY [decl] [pred]
: BODY		decls axioms

> sexp	::=	SREF word decor [expr] [rename] line_no
>		| TEXT schema | NOT sexp | PRE sexp
>		| AND sexp sexp | OR sexp sexp | IMPLIES sexp sexp 
>		| EQUIV sexp sexp | PROJECT sexp sexp | HIDE sexp [ident] 
>		| FATSEMI sexp sexp | PIPE sexp sexp | EXISTS schema sexp
>		| FORALL schema sexp | EXISTS1 schema sexp
: TEXT		text
: SREF		sref_tag sref_decor sref_params sref_renames sref_line

> rename ::=	RENAME ident ident
: RENAME	rename_to rename_from

> decl	::=	DECL [ident] expr | SDECL sexp
: DECL		decl_names decl_expr
: SDECL		ref

> pred	::=	EQUAL expr expr | MEMBER expr expr | TRUTH | FALSITY
>		| NOT pred | AND pred pred | OR pred pred
>		| EQUIV pred pred | IMPLIES pred pred | EXISTS schema pred
>		| EXISTS1 schema pred | FORALL schema pred | SPRED sexp
>		| INREL ident expr expr | PREREL ident expr
>		| LETPRED [letdef] pred
: SPRED		ref
: EQUAL		lhs rhs
: MEMBER	lhs rhs
: INREL		op rand1 rand2
: PREREL	op rand
: LETPRED	defs body

> expr	::=	REF ident [expr] line_no | NUMBER word | SEXPR sexp
>		| EXT [expr] | COMP schema (optional expr)
>		| POWER expr | TUPLE [expr] | SEQ [expr] | CROSS [expr]
>		| THETA word decor [rename] | SELECT expr selector
>		| APPLY expr expr | LAMBDA schema expr
>		| MU schema (optional expr)
>		| INGEN ident expr expr | PREGEN ident expr
>		| INOP ident expr expr | POSTOP ident expr
>		| LETEXPR [letdef] expr | IF pred expr expr
>		| BINDING [binding]
: SEXPR		ref
: REF		tag params ref_line
: NUMBER	number
: EXT		elements
: TUPLE		elements
: CROSS		factors
: THETA		the_name the_decor the_rename
: SELECT	arg field
: INGEN		tag param1 param2
: PREGEN	tag param
: INOP		op rand1 rand2
: POSTOP	op rand
: IF		if then else
: BINDING	elements
: LETEXPR	defs body

> letdef ::= EQEQ ident expr
: EQEQ		lhs rhs

> selector ::= ident | THETA word decor [rename]

> binding ::= BIND ident expr
: BIND		lhs rhs

: UNARY		arg
: BINARY	arg1 arg2
: QUANT		bvar body
